
;
; helper:
; replace extension
;
(define (morph-filename orig-name new-extension)
 (let* ((buffer (vector "" "" "")))
  (if (re-match "^(.*)[.]([^.]+)$" orig-name buffer)
   (string-append (substring orig-name 0 (car (vector-ref buffer 2))) new-extension)
  )
 )
)


(define (script-fu-speichern aimg adraw) 


    (gimp-context-push)

    (gimp-image-undo-group-start aimg)

;
; your script here!
;
	(let* (
               (tmp-path (car (gimp-image-get-filename aimg)))
               (tmp-name (car (gimp-image-get-name aimg)))
               (i-path (if (equal? tmp-path "") "Mein Bild.xcf" tmp-path))
               (i-name (if (equal? tmp-path "") "Mein Bild.xcf" tmp-name))
               
               (i-copy (car (gimp-image-duplicate aimg)))
               (i-copy-drawable (car (gimp-image-flatten i-copy)))
               )
;
; save as png
;
          (set! i-path (morph-filename i-path "png"))
          (set! i-name (morph-filename i-name "png"))

          (gimp-file-save RUN-WITH-LAST-VALS 
                          i-copy 
                          i-copy-drawable 
                          i-path 
                          i-name)
;
; save as xcf
;
          (set! i-path (morph-filename i-path "xcf"))
          (set! i-name (morph-filename i-name "xcf"))

          (gimp-file-save RUN-WITH-LAST-VALS 
                          aimg 
                          adraw
                          i-path 
                          i-name)
          )

;
; script end
;
    (gimp-image-undo-group-end aimg)
    (gimp-displays-flush)

    (gimp-context-pop)
    
)

(script-fu-register "script-fu-speichern"
  _"Speichern"
  _"Legt ein Bild auf dem Computer ab"
  "-"
  "Philip"
  "25.3.2011"
  "*"
  SF-IMAGE       "Input image" 0
  SF-DRAWABLE    "Input drawable" 0
)

(script-fu-menu-register "script-fu-speichern"
                         "<Image>/File")
